import React, { FC } from 'react';
import { InputModeOptions, StyleProp, TextStyle, ViewStyle } from 'react-native';
import { InputElementType } from '@procyon/types/form';
export type TextFieldProps<V = string> = {
    LeftIcon?: FC<any>;
    RightIcon?: FC<any>;
    autoFocus?: boolean;
    leftText?: string;
    mask?: string;
    mode?: InputModeOptions;
    multiline?: boolean;
    readonly?: boolean;
    rightText?: string;
    secret?: boolean;
    style?: {
        container?: StyleProp<ViewStyle>;
        icon?: StyleProp<ViewStyle | TextStyle>;
        input?: StyleProp<ViewStyle>;
        label?: StyleProp<TextStyle>;
        message?: StyleProp<TextStyle>;
    };
} & InputElementType<V>;
export declare const TextField: React.FC<TextFieldProps>;
